#!/bin/sh

a= . install2-init-functions

CMDLINE="$(grep -ow 'console=ttyS[^ ]*' /proc/cmdline | head -1)"
[ -n "$CMDLINE" ] || exit 0
UNIT="${CMDLINE#console=ttyS}"
UNIT="${UNIT%%,*}"	# 0
MODE="${CMDLINE#*,}"	# 115200n8
SPEED="${MODE%%n*}"	# 115200

# init; note that installer runs in *unknown* runlevel (not reaching 7)
INITCFG="$destdir/etc/inittab"
if [ -f "$INITCFG" ]; then
	echo "ttyS$UNIT" >> $destdir/etc/securetty
	echo "T0:2345:respawn:/sbin/agetty -L ttyS$UNIT $SPEED vt100" \
		>> "$INITCFG"
fi

# bootloader
# TODO: should we add "quiet" to CMDLINE here?
GRUBCFG="$destdir/etc/sysconfig/grub2"
if [ -f "$GRUBCFG" ]; then
	sed -i "s/splash/console=tty0 $CMDLINE/" "$GRUBCFG"
	cat >> "$GRUBCFG" <<-EOF
	GRUB_TERMINAL_OUTPUT="serial console"
	GRUB_TERMINAL_INPUT="serial console"
	GRUB_SERIAL_COMMAND="serial --unit=$UNIT --speed=$SPEED"
	GRUB_TIMEOUT=10
	EOF
	chroot $destdir update-grub
fi

# that stuff wasn't even working properly, and e2k fw has 115200 by default
# NB: needs to be run *after* systemd got installed (_if any_)
#     so this doesn't make a stage3's %post scriptlet
SDCFG="$destdir/lib/systemd/system/serial-getty@.service"
if [ `arch` = e2k -a -f "$SDCFG" ]; then
	sed -i "s/--keep-baud 115200,38400,9600/115200/" "$SDCFG"
fi

